package net.minecraft.src;

public enum EnumSoundLittleMaid {

    death(100, "Deid Voice. Null is no Voice", "mob.ghast.death"),
    attack(110, "Attack Voice. Null is no Voice", "mob.ghast.charge"),
    laughter(111, "Laughter Voice. Null is no Voice", ""),
    shoot(112, "shoot Voice. Null is no Voice", "mob.ghast.charge"),
    shoot_burst(113, "burst shoot Voice. Null is no Voice", "mob.ghast.charge"),
    sighting(115, "Adopt a fire Voice. Null is no Voice", ""),
    eatSugar(120, "Eat Sugar Voice. Null is no Voice", ""),
    eatSugar_MaxPower(121, "Eat Sugar to MAX healing Voice. Null is no Voice", ""),
    getCake(122, "Get Cake Voice. Null is no Voice", ""),
    Recontract(123, "Recontract Voice. Null is no Voice", ""),
    addFuel(130, "Add Fuel Voice. Null is no Voice", ""),
    cookingStart(131, "Cooking Start Voice. Null is no Voice", ""),
    cookingOver(132, "Cooking Over Voice. Null is no Voice", ""),
    healing(140, "Healing Voice. Null is no Voice", ""),
    installation(150, "Installation Voice. Null is no Voice", ""),
    collect_snow(151, "Collecting snow Voice. Null is no Voice", ""),
    hurt(160, "Dameged Voice. Null is no Voice", "mob.ghast.scream"),
    hurt_snow(161, "Dameged Voice from snowball. Null is no Voice", ""),
    hurt_fire(162, "Dameged Voice from fire. Null is no Voice", ""),
    hurt_guard(163, "Dameged Voice on Guard. Null is no Voice", "mob.blaze.hit"),
    hurt_fall(164, "Dameged Voice from Fall. Null is no Voice", ""),
    hurt_nodamege(169, "No Dameged Voice. Null is no Voice", "mob.blaze.hit"),
    
    findTarget_N(200, "Find target Normal Voice. Null is no Voice", ""),
    findTarget_B(201, "Find target Bloodsuck Voice. Null is no Voice", ""),
    findTarget_I(202, "Find target Item Voice. Null is no Voice", ""),
    findTarget_D(203, "Find target Darkness Voice. Null is no Voice", ""),
    TNT_D(210, "Enable TNT-D Voice. Null is no Voice", ""),
    
    living_morning(300, "Living Voice in Mornig. Null is no Voice", "mob.ghast.moan"),
    living_daytime(301, "Living Voice(Default) in Daytime. Null is no Voice", "mob.ghast.moan"),
    living_night(302, "Living Voice in Night. Null is no Voice", "mob.ghast.moan"),
    living_whine(303, "Living Voice at Whine. Null is no Voice", "mob.ghast.moan"),
    goodmorning(350, "Goodmorning Voice. Null is no Voice", "mob.wolf.bark"),
    goodnight(351, "Goodnight Voice. Null is no Voice", "mob.ghast.affectionate scream"),

    
	Null(0, "", null);
	
	
	private EnumSoundLittleMaid(int findex, String finfo, String fdefault) {
		index = findex;
		info = finfo;
		DefaultValue = fdefault;
	}
	
	
	public int index;
	public String info;
	public String DefaultValue;
	
}
