package net.minecraft.src;

public class SlotLittleMaidArmor extends Slot
{
    protected final int armorType;
    protected final ContainerLittleMaid inventory;

    public SlotLittleMaidArmor(ContainerLittleMaid containerlittlemaid, IInventory iinventory, int i, int j, int k, int l)
    {
        super(iinventory, i, j, k);
        inventory = containerlittlemaid;
        armorType = l;
    }

    public int getSlotStackLimit()
    {
        return 1;
    }

    public boolean isItemValid(ItemStack itemstack)
    {
        if (itemstack.getItem() instanceof ItemArmor)
        {
            return ((ItemArmor)itemstack.getItem()).armorType == armorType;
        }
        else
        {
            return false;
        }
    }
}
