package net.minecraft.src;

import org.lwjgl.opengl.GL11;

public class RenderDummy extends Render
{
    public RenderDummy()
    {
        shadowSize = 0.0F;
    }

    public void doRender(Entity entity, double d, double d1, double d2,
            float f, float f1)
    {
        GL11.glPushMatrix();
        GL11.glDisable(2896 /*GL_LIGHTING*/);
        GL11.glEnable(32826 /*GL_RESCALE_NORMAL_EXT*/);
        GL11.glEnable(2903 /*GL_COLOR_MATERIAL*/);
        GL11.glEnable(3042 /*GL_BLEND*/);
        GL11.glDisable(2884 /*GL_CULL_FACE*/);
        GL11.glBlendFunc(770, 771);
        GL11.glDisable(3553 /*GL_TEXTURE_2D*/);
        GL11.glDepthMask(false);
        GL11.glTranslatef((float)d, (float)d1, (float)d2);
        RenderHelper.enableStandardItemLighting();
        Tessellator tessellator = Tessellator.instance;
        tessellator.startDrawingQuads();
        GL11.glColor3f(1.0F, 1.0F, 1.0F);
        int i = ((EntityDummy)entity).getColor();
        int j = i >> 16 & 0xff;
        int k = i >> 8 & 0xff;
        int l = i & 0xff;
        int i1 = MathHelper.floor_float(((EntityDummy)entity).getAlpha(1.0F) * 256F);
        tessellator.setColorRGBA_I(i, i1);
        double d3 = 0.29999999999999999D;
        double d4 = 0.69999999999999996D;
        double d5 = 0.015625D;
        double d6 = 0.29999999999999999D;
        double d7 = 0.69999999999999996D;
        tessellator.addVertex(d3, d5, d6);
        tessellator.addVertex(d3, d5, d7);
        tessellator.addVertex(d4, d5, d7);
        tessellator.addVertex(d4, d5, d6);
        tessellator.draw();
        RenderHelper.disableStandardItemLighting();
        GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
        GL11.glEnable(3553 /*GL_TEXTURE_2D*/);
        GL11.glDisable(3042 /*GL_BLEND*/);
        GL11.glEnable(2884 /*GL_CULL_FACE*/);
        GL11.glDepthMask(true);
        GL11.glEnable(2896 /*GL_LIGHTING*/);
        GL11.glDisable(32826 /*GL_RESCALE_NORMAL_EXT*/);
        GL11.glPopMatrix();
    }
}
